Index: /trunk/src/VBox/Additions/common/crOpenGL/defs.py
===================================================================
--- /trunk/src/VBox/Additions/common/crOpenGL/defs.py	(revision 45483)
+++ /trunk/src/VBox/Additions/common/crOpenGL/defs.py	(revision 45484)
@@ -455,5 +455,5 @@
            "wglGetPixelFormatAttribfvEXT",
            "wglGetExtensionsStringEXT"):
-    print "%s@%d = %s_prox" % (func_name,stack_sizes[func_name],func_name)
+    print "%s = %s_prox" % (func_name,func_name)
 
 """
Index: /trunk/src/VBox/Additions/common/crOpenGL/wgl.c
===================================================================
--- /trunk/src/VBox/Additions/common/crOpenGL/wgl.c	(revision 45483)
+++ /trunk/src/VBox/Additions/common/crOpenGL/wgl.c	(revision 45484)
@@ -16,4 +16,6 @@
 #include <windows.h>
 #include <stdio.h>
+
+#include <iprt/cdefs.h>
 
 /* Currently host part will misbehave re-creating context with proper visual bits
@@ -66,5 +68,5 @@
 #endif
 
-int WINAPI wglChoosePixelFormat_prox( HDC hdc, CONST PIXELFORMATDESCRIPTOR *pfd )
+DECLEXPORT(int) WINAPI wglChoosePixelFormat_prox( HDC hdc, CONST PIXELFORMATDESCRIPTOR *pfd )
 {
     DWORD okayFlags;
@@ -163,5 +165,5 @@
 }
 
-BOOL WINAPI wglSetPixelFormat_prox( HDC hdc, int pixelFormat, 
+DECLEXPORT(BOOL) WINAPI wglSetPixelFormat_prox( HDC hdc, int pixelFormat,
         CONST PIXELFORMATDESCRIPTOR *pdf )
 {
@@ -175,5 +177,5 @@
 }
 
-BOOL WINAPI wglDeleteContext_prox( HGLRC hglrc )
+DECLEXPORT(BOOL) WINAPI wglDeleteContext_prox( HGLRC hglrc )
 {
     CR_DDI_PROLOGUE();
@@ -182,5 +184,5 @@
 }
 
-BOOL WINAPI wglMakeCurrent_prox( HDC hdc, HGLRC hglrc )
+DECLEXPORT(BOOL) WINAPI wglMakeCurrent_prox( HDC hdc, HGLRC hglrc )
 {
     ContextInfo *context;
@@ -209,5 +211,5 @@
 }
 
-HGLRC WINAPI wglGetCurrentContext_prox( void )
+DECLEXPORT(HGLRC) WINAPI wglGetCurrentContext_prox( void )
 {
     ContextInfo *context = stubGetCurrentContext();
@@ -216,5 +218,5 @@
 }
 
-HDC WINAPI wglGetCurrentDC_prox( void )
+DECLEXPORT(HDC) WINAPI wglGetCurrentDC_prox( void )
 {
     ContextInfo *context = stubGetCurrentContext();
@@ -226,5 +228,5 @@
 }
 
-int WINAPI wglGetPixelFormat_prox( HDC hdc )
+DECLEXPORT(int) WINAPI wglGetPixelFormat_prox( HDC hdc )
 {
     CR_DDI_PROLOGUE();
@@ -233,5 +235,5 @@
 }
 
-int WINAPI wglDescribePixelFormat_prox( HDC hdc, int pixelFormat, UINT nBytes,
+DECLEXPORT(int) WINAPI wglDescribePixelFormat_prox( HDC hdc, int pixelFormat, UINT nBytes,
         LPPIXELFORMATDESCRIPTOR pfd )
 {
@@ -287,5 +289,5 @@
 }
 
-BOOL WINAPI wglShareLists_prox( HGLRC hglrc1, HGLRC hglrc2 )
+DECLEXPORT(BOOL) WINAPI wglShareLists_prox( HGLRC hglrc1, HGLRC hglrc2 )
 {
     CR_DDI_PROLOGUE();
@@ -295,5 +297,5 @@
 
 
-HGLRC WINAPI VBoxCreateContext( HDC hdc, struct VBOXUHGSMI *pHgsmi )
+DECLEXPORT(HGLRC) WINAPI VBoxCreateContext( HDC hdc, struct VBOXUHGSMI *pHgsmi )
 {
     char dpyName[MAX_DPY_NAME];
@@ -325,5 +327,5 @@
 }
 
-GLint WINAPI VBoxGetWindowId( HDC hdc )
+DECLEXPORT(GLint) WINAPI VBoxGetWindowId( HDC hdc )
 {
     WindowInfo *window = stubGetWindowInfo(hdc);
@@ -343,10 +345,10 @@
 }
 
-HGLRC WINAPI wglCreateContext_prox( HDC hdc )
+DECLEXPORT(HGLRC) WINAPI wglCreateContext_prox( HDC hdc )
 {
     return VBoxCreateContext(hdc, NULL);
 }
 
-void WINAPI VBoxFlushToHost ( HGLRC hglrc )
+DECLEXPORT(void) WINAPI VBoxFlushToHost ( HGLRC hglrc )
 {
     ContextInfo *context;
@@ -366,5 +368,5 @@
 }
 
-BOOL WINAPI
+DECLEXPORT(BOOL) WINAPI
 wglSwapBuffers_prox( HDC hdc )
 {
@@ -375,5 +377,5 @@
 }
 
-BOOL WINAPI wglCopyContext_prox( HGLRC src, HGLRC dst, UINT mask )
+DECLEXPORT(BOOL) WINAPI wglCopyContext_prox( HGLRC src, HGLRC dst, UINT mask )
 {
     CR_DDI_PROLOGUE();
@@ -382,5 +384,5 @@
 }
 
-HGLRC WINAPI wglCreateLayerContext_prox( HDC hdc, int layerPlane )
+DECLEXPORT(HGLRC) WINAPI wglCreateLayerContext_prox( HDC hdc, int layerPlane )
 {
     CR_DDI_PROLOGUE();
@@ -390,5 +392,5 @@
 }
 
-PROC WINAPI wglGetProcAddress_prox( LPCSTR name )
+DECLEXPORT(PROC) WINAPI wglGetProcAddress_prox( LPCSTR name )
 {
     CR_DDI_PROLOGUE();
@@ -396,5 +398,5 @@
 }
 
-BOOL WINAPI wglUseFontBitmapsA_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase )
+DECLEXPORT(BOOL) WINAPI wglUseFontBitmapsA_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase )
 {
     CR_DDI_PROLOGUE();
@@ -403,5 +405,5 @@
 }
 
-BOOL WINAPI wglUseFontBitmapsW_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase )
+DECLEXPORT(BOOL) WINAPI wglUseFontBitmapsW_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase )
 {
     CR_DDI_PROLOGUE();
@@ -410,5 +412,5 @@
 }
 
-BOOL WINAPI wglDescribeLayerPlane_prox( HDC hdc, int pixelFormat, int layerPlane,
+DECLEXPORT(BOOL) WINAPI wglDescribeLayerPlane_prox( HDC hdc, int pixelFormat, int layerPlane,
         UINT nBytes, LPLAYERPLANEDESCRIPTOR lpd )
 {
@@ -418,5 +420,5 @@
 }
 
-int WINAPI wglSetLayerPaletteEntries_prox( HDC hdc, int layerPlane, int start,
+DECLEXPORT(int) WINAPI wglSetLayerPaletteEntries_prox( HDC hdc, int layerPlane, int start,
         int entries, CONST COLORREF *cr )
 {
@@ -426,5 +428,5 @@
 }
 
-int WINAPI wglGetLayerPaletteEntries_prox( HDC hdc, int layerPlane, int start,
+DECLEXPORT(int) WINAPI wglGetLayerPaletteEntries_prox( HDC hdc, int layerPlane, int start,
         int entries, COLORREF *cr )
 {
@@ -434,5 +436,5 @@
 }
 
-BOOL WINAPI wglRealizeLayerPalette_prox( HDC hdc, int layerPlane, BOOL realize )
+DECLEXPORT(BOOL) WINAPI wglRealizeLayerPalette_prox( HDC hdc, int layerPlane, BOOL realize )
 {
     CR_DDI_PROLOGUE();
@@ -441,5 +443,5 @@
 }
 
-DWORD WINAPI wglSwapMultipleBuffers_prox( UINT a, CONST void *b )
+DECLEXPORT(DWORD) WINAPI wglSwapMultipleBuffers_prox( UINT a, CONST void *b )
 {
     CR_DDI_PROLOGUE();
@@ -448,5 +450,5 @@
 }
 
-BOOL WINAPI wglUseFontOutlinesA_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase,
+DECLEXPORT(BOOL) WINAPI wglUseFontOutlinesA_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase,
         FLOAT deviation, FLOAT extrusion, int format,
         LPGLYPHMETRICSFLOAT gmf )
@@ -457,5 +459,5 @@
 }
 
-BOOL WINAPI wglUseFontOutlinesW_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase,
+DECLEXPORT(BOOL) WINAPI wglUseFontOutlinesW_prox( HDC hdc, DWORD first, DWORD count, DWORD listBase,
         FLOAT deviation, FLOAT extrusion, int format,
         LPGLYPHMETRICSFLOAT gmf )
@@ -466,5 +468,5 @@
 }
 
-BOOL WINAPI wglSwapLayerBuffers_prox( HDC hdc, UINT planes )
+DECLEXPORT(BOOL) WINAPI wglSwapLayerBuffers_prox( HDC hdc, UINT planes )
 {
     CR_DDI_PROLOGUE();
@@ -480,5 +482,5 @@
 }
 
-BOOL WINAPI wglChoosePixelFormatEXT_prox
+DECLEXPORT(BOOL) WINAPI wglChoosePixelFormatEXT_prox
 (HDC hdc, const int *piAttributes, const FLOAT *pfAttributes, UINT nMaxFormats, int *piFormats, UINT *nNumFormats)
 {
@@ -602,5 +604,5 @@
 }
 
-BOOL WINAPI wglGetPixelFormatAttribivEXT_prox
+DECLEXPORT(BOOL) WINAPI wglGetPixelFormatAttribivEXT_prox
 (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, int *pValues)
 {
@@ -737,5 +739,5 @@
 }
 
-BOOL WINAPI wglGetPixelFormatAttribfvEXT_prox
+DECLEXPORT(BOOL) WINAPI wglGetPixelFormatAttribfvEXT_prox
 (HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, float *pValues)
 {
@@ -872,5 +874,5 @@
 }
 
-BOOL WINAPI wglSwapIntervalEXT_prox(int interval)
+DECLEXPORT(BOOL) WINAPI wglSwapIntervalEXT_prox(int interval)
 {
     CR_DDI_PROLOGUE();
@@ -878,5 +880,5 @@
 }
 
-int  WINAPI wglGetSwapIntervalEXT_prox()
+DECLEXPORT(int)  WINAPI wglGetSwapIntervalEXT_prox()
 {
     CR_DDI_PROLOGUE();
@@ -886,5 +888,5 @@
 static GLubyte *gsz_wgl_extensions = "WGL_EXT_pixel_format WGL_ARB_pixel_format WGL_ARB_multisample";
 
-const GLubyte * WINAPI wglGetExtensionsStringEXT_prox()
+DECLEXPORT(const GLubyte *) WINAPI wglGetExtensionsStringEXT_prox()
 {
     CR_DDI_PROLOGUE();
@@ -892,5 +894,5 @@
 }
 
-const GLubyte * WINAPI wglGetExtensionsStringARB_prox(HDC hdc)
+DECLEXPORT(const GLubyte *) WINAPI wglGetExtensionsStringARB_prox(HDC hdc)
 {
     CR_DDI_PROLOGUE();