Index: trunk/src/VBox/VMM/VMMR3/VM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/VM.cpp	(revision 45523)
+++ trunk/src/VBox/VMM/VMMR3/VM.cpp	(revision 45525)
@@ -104,5 +104,7 @@
 static int                  vmR3InitRing3(PVM pVM, PUVM pUVM);
 static int                  vmR3InitRing0(PVM pVM);
-static int                  vmR3InitGC(PVM pVM);
+#ifdef VBOX_WITH_RAW_MODE
+static int                  vmR3InitRC(PVM pVM);
+#endif
 static int                  vmR3InitDoCompleted(PVM pVM, VMINITCOMPLETED enmWhat);
 #ifdef LOG_ENABLED
@@ -737,8 +739,10 @@
 #endif
                                 /*
-                                 * Init the Guest Context components.
+                                 * Init the Raw-Mode Context components.
                                  */
-                                rc = vmR3InitGC(pVM);
+#ifdef VBOX_WITH_RAW_MODE
+                                rc = vmR3InitRC(pVM);
                                 if (RT_SUCCESS(rc))
+#endif
                                 {
                                     /*
@@ -1073,10 +1077,11 @@
 
 
-/**
- * Initializes all GC components of the VM
- */
-static int vmR3InitGC(PVM pVM)
-{
-    LogFlow(("vmR3InitGC:\n"));
+#ifdef VBOX_WITH_RAW_MODE
+/**
+ * Initializes all RC components of the VM
+ */
+static int vmR3InitRC(PVM pVM)
+{
+    LogFlow(("vmR3InitRC:\n"));
 
     /*
@@ -1093,5 +1098,5 @@
     }
     else
-        Log(("vmR3InitGC: skipping because of VBOX_SUPLIB_FAKE=fake\n"));
+        Log(("vmR3InitRC: skipping because of VBOX_SUPLIB_FAKE=fake\n"));
 
     /*
@@ -1100,7 +1105,8 @@
     if (RT_SUCCESS(rc))
         rc = vmR3InitDoCompleted(pVM, VMINITCOMPLETED_GC);
-    LogFlow(("vmR3InitGC: returns %Rrc\n", rc));
+    LogFlow(("vmR3InitRC: returns %Rrc\n", rc));
     return rc;
 }
+#endif /* VBOX_WITH_RAW_MODE */
 
 
Index: trunk/src/VBox/VMM/VMMR3/VMM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/VMM.cpp	(revision 45523)
+++ trunk/src/VBox/VMM/VMMR3/VMM.cpp	(revision 45525)
@@ -536,4 +536,5 @@
 
 
+#ifdef VBOX_WITH_RAW_MODE
 /**
  * Initializes the RC VMM.
@@ -611,4 +612,5 @@
     return rc;
 }
+#endif /* VBOX_WITH_RAW_MODE */
 
 
@@ -1096,4 +1098,5 @@
 
 
+#ifdef VBOX_WITH_RAW_MODE
 /**
  * Resolve a builtin RC symbol.
@@ -1118,11 +1121,11 @@
     else if (!strcmp(pszSymbol, "g_RelLogger"))
     {
-#ifdef VBOX_WITH_RC_RELEASE_LOGGING
+# ifdef VBOX_WITH_RC_RELEASE_LOGGING
         if (pVM->vmm.s.pRCRelLoggerR3)
             pVM->vmm.s.pRCRelLoggerRC = MMHyperR3ToRC(pVM, pVM->vmm.s.pRCRelLoggerR3);
         *pRCPtrValue = pVM->vmm.s.pRCRelLoggerRC;
-#else
+# else
         *pRCPtrValue = NIL_RTRCPTR;
-#endif
+# endif
     }
     else
@@ -1130,4 +1133,5 @@
     return VINF_SUCCESS;
 }
+#endif /* VBOX_WITH_RAW_MODE */
 
 
@@ -1225,4 +1229,5 @@
 
 
+#ifdef VBOX_WITH_RAW_MODE
 /**
  * Executes guest code in the raw-mode context.
@@ -1299,4 +1304,5 @@
     }
 }
+#endif /* VBOX_WITH_RAW_MODE */
 
 
@@ -1879,4 +1885,5 @@
 }
 
+#ifdef VBOX_WITH_RAW_MODE
 
 /**
@@ -1978,4 +1985,5 @@
 }
 
+#endif /* VBOX_WITH_RAW_MODE */
 
 /**
@@ -2028,4 +2036,5 @@
 
 
+#ifdef VBOX_WITH_RAW_MODE
 /**
  * Resumes executing hypervisor code when interrupted by a queue flush or a
@@ -2050,11 +2059,11 @@
         do
         {
-#ifdef NO_SUPCALLR0VMM
+# ifdef NO_SUPCALLR0VMM
             rc = VERR_GENERAL_FAILURE;
-#else
+# else
             rc = SUPR3CallVMMR0Fast(pVM->pVMR0, VMMR0_DO_RAW_RUN, 0);
             if (RT_LIKELY(rc == VINF_SUCCESS))
                 rc = pVCpu->vmm.s.iLastGZRc;
-#endif
+# endif
         } while (rc == VINF_EM_RAW_INTERRUPT_HYPER);
 
@@ -2062,15 +2071,15 @@
          * Flush the loggers.
          */
-#ifdef LOG_ENABLED
+# ifdef LOG_ENABLED
         PRTLOGGERRC pLogger = pVM->vmm.s.pRCLoggerR3;
         if (    pLogger
             &&  pLogger->offScratch > 0)
             RTLogFlushRC(NULL, pLogger);
-#endif
-#ifdef VBOX_WITH_RC_RELEASE_LOGGING
+# endif
+# ifdef VBOX_WITH_RC_RELEASE_LOGGING
         PRTLOGGERRC pRelLogger = pVM->vmm.s.pRCRelLoggerR3;
         if (RT_UNLIKELY(pRelLogger && pRelLogger->offScratch > 0))
             RTLogFlushRC(RTLogRelDefaultInstance(), pRelLogger);
-#endif
+# endif
         if (rc == VERR_TRPM_PANIC || rc == VERR_TRPM_DONT_PANIC)
             VMMR3FatalDump(pVM, pVCpu, rc);
@@ -2085,4 +2094,5 @@
     }
 }
+#endif /* VBOX_WITH_RAW_MODE */
 
 